<?php

namespace Drupal\cmlmigrations\Drush;

use Drush\Commands\DrushCommands;

/**
 * A Drush commandfile.
 */
class DrushCmd extends DrushCommands {

  /**
   * Run cmlmigrations.
   *
   * @command cmlmigrations
   * @usage cmlmigrations
   */
  public function cmlmigrationsRun() {
    // $config = \Drupal::config('cmlmigrations.settings');
    $this->output()->writeln("cmlmigrations:: RUN");
    $lock = \Drupal::lock();
    $delay = 5;
    if (!$lock->acquire('cmlmigrations')) {
      \Drupal::logger('cmlmigrations')->notice("Lock!! await {$delay}sec lock availability");
      while ($lock->wait('cmlmigrations', $delay)) {
        \Drupal::logger('cmlmigrations')->notice("Drush await {$delay}sec lock availability");
      };
      $lock->acquire('cmlmigrations');
    }
    \Drupal::logger('cmlmigrations')->notice("lock:: set");
    \Drupal::service('cmlmigrations.migrate')->import();
    \Drupal::logger('cmlmigrations')->notice("lock:: release");
    $lock->release('cmlmigrations');
  }

}
